unit NClipboard;

interface

uses Windows;

type
  Clipboard = class
    class function GetText: string;
    class procedure SetText(const Buf; NBytes: Cardinal); overload;
    class procedure SetText(const S: string); overload;
  end;

implementation

class function Clipboard.GetText: string;
var
  h: HGLOBAL;
  size: DWORD;
  p: PChar;
begin
  Result := '';
  if OpenClipboard(0) then
    try
      h := GetClipboardData(CF_TEXT);
      if h = 0 then
        Exit;
      size := GlobalSize(h);
      if size = 0 then
        Exit;
      p := GlobalLock(h);
      if not Assigned(p) then
        Exit;
      SetString(Result, p, size-1); // -1 for null terminate
      GlobalUnlock(h);
    finally
      CloseClipboard;
    end;
end;

class procedure Clipboard.SetText(const S: string);
begin
  SetText(S[1], Length(S));
end;

class procedure Clipboard.SetText(const Buf; NBytes: Cardinal);
var
  h: HGLOBAL;
  p: PChar;
begin
  if OpenClipboard(0) then
    try
      h := GlobalAlloc(GHND, NBytes+1); // +1 for null terminate
      if h = 0 then
        Exit;
      try  
        p := GlobalLock(h);
        if not Assigned(p) then
          Exit;
        Move(Buf, p^, NBytes);
        GlobalUnlock(h);
        EmptyClipboard;
        SetClipboardData(CF_TEXT, h);
      finally
        GlobalFree(h);
      end;
    finally
      CloseClipboard;
    end;
end;

end.
